# ckb-next: RGB Driver for Linux

<a target="_blank" href="https://web.libera.chat/?channels=#ckb-next"><img src="https://img.shields.io/badge/%23irc-libera.chat-blue.svg" height="20" alt="irc.libera.chat #ckb-next" /></a>

**ckb-next** is an open-source driver for Corsair keyboards and mice. It aims to bring the features of Corsair's proprietary CUE software to Linux operating systems. This project is currently a work in progress, but it already supports much of the same functionality, including full RGB animations. More features are coming soon. Testing and bug reports are appreciated!

> __DISCLAIMER__: ckb-next is not an official Corsair product. It is licensed under the GNU General Public License (version 2) in the hope that it will be useful, but with NO WARRANTY of any kind.

![Screenshot](https://i.imgur.com/zMK9jOP.png)

Major features:

- Control multiple devices independently
- United States and European keyboard layouts
- Customizable key bindings
- Per-key lighting and animation
- Reactive lighting
- Multiple profiles/modes with hardware save function
- Adjustable mouse DPI with ability to change DPI on button press

### Important information regarding macOS
macOS is no longer officially supported. For more information, please refer to [issue #660](https://github.com/ckb-next/ckb-next/issues/660).

### General information

Most of the information can be found on [ckb-next wiki pages](https://github.com/ckb-next/ckb-next/wiki).

[Supported devices](https://github.com/ckb-next/ckb-next/wiki/Supported-Hardware).

[Linux Installation](https://github.com/ckb-next/ckb-next/wiki/Linux-Installation).

[Troubleshooting](https://github.com/ckb-next/ckb-next/wiki/Troubleshooting).

[Known Issues](https://github.com/ckb-next/ckb-next/wiki/Known-issues).

[Contributing](https://github.com/ckb-next/ckb-next/wiki/Contributing).

[Community Pipe Animation Scripts](https://github.com/ckb-next/ckb-next/wiki/Community-Pipe-Scripts).

### Contact

Maintainers reserve the rights to modify and remove issues, pull requests and comments therein, that are denunciating, off-topic, harmful, hateful and overall inappropriate.
Please be appreciative, humble and kind to each other.

* IRC chat: `#ckb-next` channel at [irc.libera.chat](https://web.libera.chat/?channels=#ckb-next)
* Mailing list: [ckb-next@googlegroups.com](https://groups.google.com/forum/#!forum/ckb-next)
* [GitHub Issues](https://github.com/ckb-next/ckb-next/issues)
